#version 300 es

precision highp float;

in vec2 var_uv;
in float var_time;

layout( location = 0 ) out vec4 F;

uniform sampler2D glfx_BACKGROUND;
uniform sampler2D glfx_TEXT0;

layout(std140) uniform glfx_BASIS_DATA
{
	vec4 unused;
	vec4 glfx_SCREEN;
};

// uniform sampler2D tex_1;
vec2 scale_uv(vec2 uv, float scale)
{
    float inv_scale = 1. / scale;
    return vec2(mat3(1., 0., 0., 0., inv_scale, 0., 0.5, 0.5, 1.0) * vec3(uv - 0.5, 1.));
}

vec2 aspect_fill_uv_tex(vec2 uv)
{
    vec2 textureSize = vec2(textureSize(glfx_TEXT0, 0));
    float aspect_ratio = glfx_SCREEN.y / glfx_SCREEN.x;
    float texture_aspect_ratio = textureSize.y / textureSize.x;
    float scale_x = 1.0;
    float scale_y = 1.0;
    if (texture_aspect_ratio > aspect_ratio) {
        scale_y = texture_aspect_ratio / aspect_ratio;
    } else {
        scale_x = aspect_ratio / texture_aspect_ratio;
    }
    
    float inv_scale_x = 1. / scale_x;
    float inv_scale_y = 1. / scale_y;
    
    return vec2(mat3(inv_scale_x, 0., 0., 0., inv_scale_y, 0., 0.5, 0.5, 1.0) * vec3(uv - 0.5, 1.));
}

vec2 aspect_fit_uv_tex(vec2 uv)
{
    vec2 textureSize = vec2(textureSize(glfx_TEXT0, 0));
    float aspect_ratio = glfx_SCREEN.y / glfx_SCREEN.x;
    float texture_aspect_ratio = textureSize.y / textureSize.x;
    float scale_x = 1.0;
    float scale_y = 1.0;

    float inv_scale_x;
    float inv_scale_y;

    if (texture_aspect_ratio > aspect_ratio) {
        scale_y = texture_aspect_ratio / aspect_ratio;

        inv_scale_x = 1. / scale_x * texture_aspect_ratio / aspect_ratio;
        inv_scale_y = 1. / scale_y * texture_aspect_ratio / aspect_ratio;
    } else {
        scale_y = texture_aspect_ratio / aspect_ratio;

        inv_scale_x = 1.;
        inv_scale_y = 1. / scale_y;
    }
    
    return vec2(mat3(inv_scale_x, 0., 0., 0., inv_scale_y, 0., 0.5, 0.5, 1.0) * vec3(uv - 0.5, 1.));
}

void main()
{
    vec2 uv = var_uv;
    uv.y = 1. - uv.y;
    // uv = scale_uv(uv, 0.1);
    uv = aspect_fit_uv_tex(uv);
    vec4 color = vec4(1., 0., 0., 1.0);
    float opacity = texture(glfx_TEXT0,uv).x * color.w;
    // color.rgb = texture(tex_1, uv).rgb;

    F = vec4(texture(glfx_TEXT0,uv).rgb, opacity);
}
